#define _USE_MATH_DEFINES
#include <math.h>
#include <stdlib.h>
#include <iostream>
#include <fstream>
#include <vector>
#include <iomanip>
#include <sstream>

long double m = 1.5, L = 1, gma = 2.1, zeta = 1, N_obs = 37618, N_model = N_obs-1, P_0 = 0;

using namespace std;

int main(int argc, char *argv[]) {

  long double Beta = 1.0/(gma-1);

  long double Delta = 0;

  do{

      P_0 = 0;  

      if(Delta == 0) {
         Delta=1;
      }

      N_model = N_model+Delta; 

      long double i = 0;

      for (i = 1.0 ; i <= N_model; i++) {

          long double I_i=(1/(1-Beta))*(1-pow(i,-(1-Beta)));
          long double L_i=(2*L*(1-Beta)/((2*Beta-1)*pow((1-pow(N_model,-(1-Beta))),2)))*(pow(N_model/i, (2*Beta-1))-1)*(1-pow(i, -(1-Beta)));
          long double m_i=m+L_i;

          long double p_i_l = 1;

          long double l = 0;

          for(l = 1.0; l < i; l++) {

              long double P_l_i = m_i*pow(l/i, -Beta)/(i*I_i);
          
              if(P_l_i > 1) {
                 P_l_i = 1;
              }

              p_i_l = p_i_l*(1-P_l_i);

              if((p_i_l < 0) || (p_i_l > 1)) {
                 cout<<"Error\n";
              }

          }

          for(l = i+1; l <= N_model; l++) {

              long double I_l=(1/(1-Beta))*(1-pow(l,-(1-Beta)));
              long double L_l=(2*L*(1-Beta)/((2*Beta-1)*pow((1-pow(N_model,-(1-Beta))),2)))*(pow(N_model/l, (2*Beta-1))-1)*(1-pow(l, -(1-Beta)));
              long double m_l=m+L_l;

              long double P_i_l = m_l*pow(i/l, -Beta)/(l*I_l); 

              if(P_i_l > 1) {
                 P_i_l = 1;
              }

              p_i_l = p_i_l*(1-P_i_l);

              if((p_i_l < 0) || (p_i_l >1)) {
                 cout<<"Error\n";
                 exit(-1);
              }

          }
         
          P_0 = P_0 + p_i_l;
      }

      P_0 = P_0/N_model;

      cout<<N_obs<<" "<<N_model<<" "<<P_0<<"\n";

      Delta = int(N_obs - N_model*(1-P_0));

   } while(int(N_model*(1-P_0))!= N_obs);

   cout<<N_model<<"\n";
}
  
